#! /usr/bin/python
# coding: utf-8

import gtk

values = {
	"Couleur": ("rouge", "verte", "bleue", "jaune", "blanche"),
	"Nationalité": ("anglais", "suédois", "norvégien", "allemand", "danois"),
	"Position": ("1", "2", "3", "4", "5"),
	"Cigares": ("Prince", "Pall Mall", "Dunhill", "Blend", "Blue Master"),
	"Boisson": ("thé", "lait", "bière", "eau", "café"),
	"Animal": ("Cheval", "Chien", "Poisson", "Chat", "Oiseau")
}

def toggle_to_workbook(button):
	workbook.set_current_page(results.get_current_page())
	win.remove(results)
	win.add(workbook)

def toggle_to_results(button):
	results.set_current_page(workbook.get_current_page())
	win.remove(workbook)
	win.add(results)

def mousein(evbox, event, krow, kcol, vcol, vrow):
	for val in checks[krow][kcol].keys():
		checks[krow][kcol][val][vrow].modify_bg(gtk.STATE_NORMAL,
			ev.get_style().base[gtk.STATE_PRELIGHT])
	for val in checks[krow][kcol][vcol].keys():
		checks[krow][kcol][vcol][val].modify_bg(gtk.STATE_NORMAL,
			ev.get_style().base[gtk.STATE_PRELIGHT])

def mouseout(evbox, event, krow, kcol, vcol, vrow):
	for val in checks[krow][kcol].keys():
		checks[krow][kcol][val][vrow].modify_bg(gtk.STATE_NORMAL,
			ev.get_style().bg[gtk.STATE_NORMAL])
	for val in checks[krow][kcol][vcol].keys():
		checks[krow][kcol][vcol][val].modify_bg(gtk.STATE_NORMAL,
			ev.get_style().bg[gtk.STATE_NORMAL])

def click(evbox, event, krow, kcol, vcol, vrow):
	xobve = checks[kcol][krow][vrow][vcol]
	if (evbox.get_child().get_text() == "✓"):
		if (event.button != 1): return
		evbox.get_child().set_text(" ")
		xobve.get_child().set_text(" ")
		founds[kcol][krow][vcol].set_text("")
		founds[krow][kcol][vrow].set_text("")
	elif (evbox.get_child().get_text() != " "):
		if (event.button == 1): return
		evbox.get_child().set_text(" ")
		xobve.get_child().set_text(" ")
	elif (event.button == 1):
		evbox.get_child().set_text("✓")
		xobve.get_child().set_text("✓")
		founds[krow][kcol][vrow].set_text(vcol)
		founds[kcol][krow][vcol].set_text(vrow)
	else:
		evbox.get_child().set_text("✗")
		xobve.get_child().set_text("✗")

workbook = gtk.Notebook()
workbook.set_property("tab-hborder", 0)
workbook.set_property("tab-vborder", 0)
workbook.set_property("homogeneous", True)

results = gtk.Notebook()
results.set_property("tab-hborder", 0)
results.set_property("tab-vborder", 0)
results.set_property("homogeneous", True)

l = 65535
checks,founds = {},{}
for key in values.keys():
	checks.setdefault(key, {})
	founds.setdefault(key, {})
	
	workpage = gtk.Table()
	workbook.append_page(workpage, gtk.Label(key))
	workbook.child_set_property(workpage, "tab-expand", True)
	
	respage = gtk.Table()
	results.append_page(respage, gtk.Label(key))
	results.child_set_property(respage, "tab-expand", True)
	respage.attach(gtk.Label(key), 0, 1, 0, 1)
	
	i,j = 1,1
	for k in values.keys():
		if (k == key): continue
		checks[key].setdefault(k, {})
		founds[key].setdefault(k, {})
		
		respage.attach(gtk.VSeparator(), i*2, i*2+1, 0, l)
		respage.attach(gtk.Label(k), i*2+1, i*2+2, 0, 1)
		for n in range(len(values[key])):
			label = gtk.Label("")
			founds[key][k].setdefault(values[key][n], label)
			respage.attach(label, i*2+1, i*2+2, n*2+2, n*2+3)
		
		sep = gtk.VSeparator()
		sep.modify_bg(gtk.STATE_NORMAL,
			sep.get_style().bg[gtk.STATE_SELECTED])
		for val in values[k]:
			checks[key][k].setdefault(val, {})
			
			workpage.attach(sep, j*2, j*2+1, 0, l)
			label = gtk.Label(val)
			label.set_angle(85)
			workpage.attach(label, j*2+1, j*2+2, 0, 1)
			sep = gtk.VSeparator()
			
			for n in range(len(values[key])):
				ev = gtk.EventBox()
				ev.add(gtk.Label(" "))
				checks[key][k][val][values[key][n]] = ev
				ev.connect("button-press-event", click,
					key, k, val, values[key][n])
				ev.connect("enter-notify-event", mousein,
					key, k, val, values[key][n])
				ev.connect("leave-notify-event", mouseout,
					key, k, val, values[key][n])
				workpage.attach(ev, j*2+1, j*2+2, n*2+2, n*2+3)
			j += 1
		i += 1
	
	for i in range(len(values[key])):
		respage.attach(gtk.HSeparator(), 0, l, i*2+1, i*2+2)
		respage.attach(gtk.Label(values[key][i]), 0, 1, i*2+2, i*2+3)
		workpage.attach(gtk.HSeparator(), 0, l, i*2+1, i*2+2)
		workpage.attach(gtk.Label(values[key][i]), 0, 1, i*2+2, i*2+3)

theme = gtk.icon_theme_get_default()
results.show_all()

button = gtk.Button()
style = gtk.RcStyle()
style.xthickness = 0
style.ythickness = 0
button.modify_style(style)
button.add(gtk.image_new_from_pixbuf(theme.load_icon(
	"display", 16, gtk.ICON_LOOKUP_USE_BUILTIN)))
button.connect("clicked", toggle_to_results)
workbook.set_action_widget(button, gtk.PACK_END)
button.show_all()

button = gtk.Button()
style = gtk.RcStyle()
style.xthickness = 0
style.ythickness = 0
button.modify_style(style)
button.add(gtk.image_new_from_pixbuf(theme.load_icon(
	"text-editor", 16, gtk.ICON_LOOKUP_USE_BUILTIN)))
button.connect("clicked", toggle_to_workbook)
results.set_action_widget(button, gtk.PACK_END)
button.show_all()

win = gtk.Window()
win.set_title("Grille Logique")
win.set_icon(theme.load_icon("gnome-run", 48, gtk.ICON_LOOKUP_USE_BUILTIN))
win.connect("destroy", gtk.main_quit)
win.add(workbook)
win.show_all()
gtk.main()
